#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <fcntl.h>

#define MEMUSE1 33554432  // 32 MB
#define MEMUSE2 1048576   // 1 MB
#define MEMUSE3 402653184 // 384 MB

#define ITER 100
#define PATTERN 0x55555555

void  ChildProcess(void)
{
	void *p, *pp, *ppp;

	p = malloc(MEMUSE1);
	memset(p,PATTERN,MEMUSE1);
	pp = malloc(MEMUSE2);
	ppp = malloc(MEMUSE3);
	memset(ppp,PATTERN,MEMUSE3);
	//sleep(10);
	free(p);
	free(ppp);
	memset(pp,PATTERN,MEMUSE2);
	free(pp);

    exit(0);
}

int  main(void)
{
	pid_t   pid;
	int     status;
	int     j;

	for(j = 0; j < ITER; j++) {     
		if ((pid = fork()) < 0) {
			printf("Failed to fork process 1\n");
			exit(1);
        }
		else if (pid == 0) 
			ChildProcess();

		wait(&status);
	}

	exit(0);
}
